// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2017 Thomas Klose & Torsten Schache, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using System;

using Hiperscan.SGS;


namespace Hiperscan.Extensions.ApoIdentCommon
{
	
	public static class FinderExtension
	{
		public static bool WriteCalibrationDate(this Finder  finder, DateTime date)
		{
			try 
			{
				int val1;
				int val2;				
				long ticks = date.Ticks;
				val1 = (int)(ticks >> 32);
				val2 = (int) ticks;
				finder.Device.WriteEEPROM(0, val1);
				finder.Device.WriteEEPROM(1, val2);
				return true;
			} 
			catch (Exception) 
			{
				return false;
			}
		}
		
		public static DateTime ReadCalibrationDate(this Finder finder)
		{
			try
			{
				int val1 = finder.Device.ReadEEPROM(0);
				int val2 = finder.Device.ReadEEPROM(1);				
				long ticks = ((long)val1 << 32);
				ticks += (uint)val2;
				return new DateTime(ticks);
			}
			catch(Exception)
			{
				return DateTime.MinValue;
			}
		}
	}
}

